﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Aml.Engine.CAEX;
using Aml.Engine.CAEX.Extensions;

namespace AutomationMLProgrammierung
{
    public partial class Form1 : Form
    {
        CAEXDocument myDoc = null;
        string path = @"c:\temp\MeinErstesAML.aml";
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            myDoc = CAEXDocument.New_CAEXDocument();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            myDoc = CAEXDocument.LoadFromFile(path);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            myDoc.SaveToFile(path, true);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            //Erzeugen von Bibliotheken
            var IH = myDoc.CAEXFile.InstanceHierarchy.Append("MyInstanceHierarchy");
            var SUCL = myDoc.CAEXFile.SystemUnitClassLib.Append("MySUC-Library");
            var RCL = myDoc.CAEXFile.RoleClassLib.Append("MyRoleLibrary");
            var ICL = myDoc.CAEXFile.InterfaceClassLib.Append("MyInterfaceClassLibrary");
            var ATL = myDoc.CAEXFile.AttributeTypeLib.Append("MyAttributetypeLibrary");

            //Hinzufügen von Klassen
            var Motor = SUCL.SystemUnitClass.Append("Motor");

            //ein paar Innereien
            Motor.InternalElement.Append("Welle");
            Motor.InternalElement.Append("Gehäuse");
            Motor.Attribute.Append("Gewicht");

            var BenzinMotor = SUCL.SystemUnitClass.Append("BenzinMotor");
            BenzinMotor.RefBaseClassPath = "MySUC-Library/Motor";

            //Hinzufügen von Attributen
            //Variante 1: via Append mit nachträglicher Modifikation des Value
            var Hersteller = BenzinMotor.Attribute.Append("Hersteller");
            Hersteller.Value = "Volkswagen";

            //Variante 2: via SetAttributeValue, dies erzeugt das Attribut oder, 
            //falls schon vorhanden, setzt den Wert neu
            var Spritsorte = BenzinMotor.SetAttributeValue("Spritsorte", "Super");

            //Programmieren von InternalElements in der Instanzhierarchie
            var AutoIE = IH.InternalElement.Append("Auto");
            var MotorIE = Motor.CreateClassInstance();
            AutoIE.Insert(MotorIE);

            //Finden von Klassen über den Pfad
            var BenzinMotorKlasse = myDoc.FindByPath("MySUC-Library/BenzinMotor", false);
            if(BenzinMotorKlasse != null)
            {
                //wenn die Klasse gefunden wurde, soll eine Instanz erzeugt werden. Diese Methode erfordert die Umwandlung der Klasse in einen SystemUnitFamilyType
                var neuerBenzinMotor = ((SystemUnitFamilyType)(BenzinMotorKlasse)).CreateClassInstance();
                AutoIE.Insert(neuerBenzinMotor);
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            var isvalid = myDoc.Validate(out var err);
        }
    }
}
